#include "gp_gfx.h"
#include <stdlib.h>
#include <string.h>

u32 framebuffers[FBUF_COUNT];
u32 nflip = 0;
int console_write_y = 1;

#define SIZE (320*240*2)

void initGfx()
{
	int i;
	for (i=0;i<FBUF_COUNT;i++)
	{
		framebuffers[i] = (u32)malloc(SIZE+4096);
		framebuffers[i] = (framebuffers[i]+4095)&0xfffff000;
		gp_setMMU(framebuffers[i], ((unsigned char*)framebuffers[i])+SIZE-1,0xFFA);
	}
	gp_initFramebuffer((void*)framebuffers[0],16,85);
	nflip = 1;
}

void clearScreen()
{
	int i;
	console_write_y = 1;
	for (i=0;i<FBUF_COUNT;i++)
		memset((void*)framebuffers[i],0,SIZE);
}

void flip(u32 sync)
{
	gp_setFramebuffer((void*)framebuffers[nflip],sync);
	nflip += 1;
	if (nflip==FBUF_COUNT)
		nflip=0;
}

void error(char *s)
{
	memset((void*)framebuffers[nflip],0xff,SIZE);
	if (s!=NULL)
		gp_drawString(1,1,strlen(s),s,0x0000,(void*)framebuffers[nflip]);
	else
		gp_drawString(1,1,10,"NULL ERROR",0x0000,(void*)framebuffers[nflip]);
	flip(1);
	while(1);
}

void console_write(char *txt,u16 COULEUR)
{
	char* TEXT = (txt==NULL)?"NONE":txt;
	int l = strlen(TEXT),i;
	if (console_write_y>230)
	{
		clearScreen();
		console_write_y = 1;
	}
	for (i=0;i<FBUF_COUNT;i++)
		gp_drawString(1,console_write_y,l,TEXT,COULEUR,(u16*)framebuffers[i]);
	console_write_y+=11*((l/40)+1);
}

void console_write_no_lineup(char *TEXT,u16 COULEUR)
{
	int i;
	for (i=0;i<FBUF_COUNT;i++)
		gp_drawString(1,console_write_y,strlen(TEXT),TEXT,COULEUR,(u16*)framebuffers[i]);
}

u16* getCurrentBuffer()
{
	return (u16*)framebuffers[nflip];
}

void drawTextAt(char* text,int x,int y,u16 color)
{
	gp_drawString(x,y,strlen(text),text,color,(u16*)framebuffers[nflip]);
}
