
// main.cpp

// includes

#include <cstdio>
#include <cstdlib>

#include "attack.h"
#include "book.h"
#include "hash.h"
#include "move_do.h"
#include "option.h"
#include "pawn.h"
#include "piece.h"
#include "protocol.h"
#include "random.h"
#include "square.h"
#include "trans.h"
#include "util.h"
#include "value.h"
#include "vector.h"

#if defined(__GP32__)
#include "gp_main.h"
#endif

// functions

// main()

int main() {

#if defined(__GP32__)
   gp_initAll();
#endif

   // init

   util_init();
   my_random_init(); // for opening book

#if !defined(__GP32__)
   printf("Fruit 2.1 UCI by Fabien Letouzey\n");
#endif

   // early initialisation (the rest is done after UCI options are parsed in protocol.cpp)

   option_init();

   square_init();
   piece_init();
   pawn_init_bit();
   value_init();
   vector_init();
   attack_init();
   move_do_init();

   random_init();
   hash_init();

   trans_init(Trans);
   book_init();

   // loop

   loop();

   return EXIT_SUCCESS;
}

// end of main.cpp

